﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ThreadpoolSample
{
    class Program
    {
        static void Main(string[] args)
        {
            // den Threadpool erforschen
            int maxThreads;
            int asyncThreads;
            ThreadPool.GetMaxThreads(out maxThreads, out asyncThreads);
            Console.WriteLine("Max. Anzahl Threads: {0}", maxThreads);
            Console.WriteLine("Max. Anzahl E/A-Threads: {0}", asyncThreads);
            Console.WriteLine(new string('-', 40));

            // Benachrichtigungsereignis, Zustand 'nicht signalisieren'
            AutoResetEvent ready = new AutoResetEvent(false);

            // Anfordern eines Threads aus dem Pool
            ThreadPool.QueueUserWorkItem(new WaitCallback(Calculate), ready);
            Console.WriteLine("Der Hauptthread wartet ...");

            // Hauptthread in den Wartezustand setzen
            ready.WaitOne();

            Console.WriteLine("Sekundärthread ist fertig.");
            Console.ReadLine();
        }


        public static void Calculate(object obj)
        {
            Console.WriteLine("Im Sekundärthread");
            Thread.Sleep(5000);
            // Ereigniszustand auf 'signalisieren' festlegen
            ((AutoResetEvent)obj).Set();
        }
    }
}
