﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FlowDocumentWithCode
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            FlowDocumentReader flowReader = new FlowDocumentReader();
            FlowDocument document = new FlowDocument();
            flowReader.Document = document;
            this.Content = flowReader;

            // Erster Block - Paragraph
            Paragraph para1 = new Paragraph();
            para1.FontSize = 22;
            para1.Background = new SolidColorBrush(Colors.LightBlue);
            para1.FontFamily = new FontFamily("Arial");
            para1.TextAlignment = TextAlignment.Center;
            para1.Padding = new Thickness(10);
            TextBlock textBlock1 = new TextBlock();
            textBlock1.VerticalAlignment = System.Windows.VerticalAlignment.Center;
            textBlock1.Inlines.Add(new Bold(new Run("Wir planen Ihren Traumurlaub !")));
            para1.Inlines.Add(textBlock1);
            document.Blocks.Add(para1);

            // Zweiter Block - Paragraph
            Paragraph para2 = new Paragraph();
            TextBlock textBlock2 = new TextBlock();
            textBlock2.FontSize = 14;
            textBlock2.TextWrapping = TextWrapping.Wrap;
            textBlock2.FontFamily = new FontFamily("Arial");
            textBlock2.Inlines.Add(new Run("Buchen Sie jetzt Ihrem Traumurlaub auf dem fünften Kontinent. Die Reise führt Sie entlang der Ostküste durch traumhafte Landschaften und an wunderschönen Stränden und Inseln vorbei von Cairns nach Brisbane."));
            para2.Inlines.Add(textBlock2);
            document.Blocks.Add(para2);

            // Dritter Block - Tabelle
            Table table = new Table();
            table.FontFamily = new FontFamily("Arial");
            // 1. Spalte
            TableColumn col1 = new TableColumn();
            col1.Width = new GridLength(350);
            table.Columns.Add(col1);
            // 2. Spalte
            TableColumn col2 = new TableColumn();
            col2.Width = new GridLength(100);
            table.Columns.Add(col2);

            TableRowGroup rowGroup = new TableRowGroup();
            TableRow row1 = new TableRow();
            // Zelle 1, Reihe 1      
            TableCell cell00 = new TableCell(new Paragraph(new Run("Australien - 3 wöchige Rundreise")));
            cell00.BorderThickness = new Thickness(1);
            cell00.BorderBrush = new SolidColorBrush(Colors.Black);
            row1.Cells.Add(cell00);
            // Zelle 2, Reihe 1
            TableCell cell01 = new TableCell(new Paragraph(new Run("5570,-€")));
            cell01.TextAlignment = TextAlignment.Right;
            cell01.BorderThickness = new Thickness(1);
            cell01.BorderBrush = new SolidColorBrush(Colors.Black);
            row1.Cells.Add(cell01);

            rowGroup.Rows.Add(row1);
            table.RowGroups.Add(rowGroup);
            document.Blocks.Add(table);
        }
    }
}
