﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;

namespace GetStandardTemplate
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void btnShowTemplate_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Erzeugen eines Objekts von dem in der Textbox angegebenen Typ
                Assembly assembly = Assembly.GetAssembly(stackPanel.GetType());
                Type controlType = assembly.GetType("System.Windows.Controls." + txtControl.Text.Trim());
                Control ctrl = (Control)controlType.GetConstructor(Type.EmptyTypes).Invoke(null);
                stackPanel.Children.Add(ctrl);

                // Standard-Template ermitteln und im TextBlock-Control eintragen
                StringBuilder builder = new StringBuilder();
                XmlWriterSettings settings = new XmlWriterSettings();
                settings.Indent = true;
                XmlWriter writer = XmlWriter.Create(builder, settings);
                XamlWriter.Save(ctrl.Template, writer);
                writer.Close();
                txtOutput.Text = builder.ToString();

                stackPanel.Children.Remove(ctrl);
            }
            catch (Exception ex)
            {
                txtOutput.Text = "FEHLER: " + ex.Message;
            }
        }
    }
}
