﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CollectionDynamicFilterSample
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private List<Person> liste = new List<Person>();
        private ListCollectionView view;

        public MainWindow()
        {
            FillListe();
            InitializeComponent();
            lstPersons.ItemsSource = liste;
            view = CollectionViewSource.GetDefaultView(lstPersons.ItemsSource) as ListCollectionView;
        }

        private void FillListe()
        {
            liste.Add(new Person { Name = "Müller", Alter = 43, Ort = "Duisburg" });
            liste.Add(new Person { Name = "Meier", Alter = 43, Ort = "Bonn" });
            liste.Add(new Person { Name = "Schmidt", Alter = 43, Ort = "Essen" });
            liste.Add(new Person { Name = "Schulze", Alter = 43, Ort = "Köln" });
            liste.Add(new Person { Name = "Schneider", Alter = 43, Ort = "Essen" });
            liste.Add(new Person { Name = "mayer", Alter = 43, Ort = "Düsseldorf" });
        }

        private void btnSetFilter_Click(object sender, RoutedEventArgs e)
        {
            FilterPersonByCity filter = new FilterPersonByCity(txtCity.Text);
            if (txtCity.Text == "") view.Filter = null;
            else view.Filter = new Predicate<object>(filter.FilterPersons);
        }
    }

    class FilterPersonByCity
    {
        public string Ort { get; set; }

        public FilterPersonByCity(string city)
        {
            Ort = city;
        }

        public bool FilterPersons(object item)
        {
            Person pers = (Person)item;
            return (pers.Ort == Ort);
        }
    }

    class Person
    {
        public string Name { get; set; }
        public int Alter { get; set; }
        public string Ort { get; set; }
    }
}
