﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.Data.SqlClient;
using System.ComponentModel;

namespace NavigationSample
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private BindingListCollectionView view;

        public MainWindow()
        {
            // Tabelle 'Products' abrufen
            SqlConnection con = new SqlConnection();
            con.ConnectionString = @"Server=.\SQLEXPRESS;Database=Northwind;Integrated Security=SSPI";
            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Products", con);
            da.Fill(ds);         
            InitializeComponent();  

            this.DataContext = ds.Tables[0];
            view = (BindingListCollectionView)CollectionViewSource.GetDefaultView(this.DataContext);
            view.CurrentChanged += view_CurrentChanged;
        }

        void view_CurrentChanged(object sender, EventArgs e)
        {
            txtPosition.Text = "Datensatz " + (view.CurrentPosition + 1).ToString() + " von " + view.Count.ToString();
            cmdPrevious.IsEnabled = view.CurrentPosition > 0;
            cmdNext.IsEnabled = view.CurrentPosition < view.Count - 1; 
        }

        private void lstProducts_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            view.MoveCurrentTo(lstProducts.SelectedItem);
        }

        private void cmdNext_Click(object sender, RoutedEventArgs e)
        {
            view.MoveCurrentToNext();  
        }

        private void cmdPrevious_Click(object sender, RoutedEventArgs e)
        {
            view.MoveCurrentToPrevious();
        }
    }
}
