﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.Objects;
using System.Data.Common;

namespace ConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            Listing_40_1();
            //Listing_40_2();
            //Listing_40_3();
            //Listing_40_4();

            Console.ReadLine();
        }

        static void Listing_40_1()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = context.Products.First(p => p.ProductID == 1);
                query.ProductName = "Kuchen";
                // Konflikt simulieren
                Console.WriteLine("2. User simulieren ...");
                Console.ReadLine();
                // Änderungen speichern
                context.SaveChanges();
                Console.WriteLine("DB aktualisiert.");
            }
        }

        static void Listing_40_2()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = context.Products.First(p => p.ProductID == 1);
                query.ProductName = "Kuchen";
                // Konflikt simulieren
                Console.WriteLine("2. User simulieren ...");
                Console.ReadLine();
                // Änderungen speichern
                try
                {
                    context.SaveChanges();
                }
                catch (OptimisticConcurrencyException ex)
                {
                    Console.WriteLine(ex.Message);
                    Console.ReadLine();
                    return;
                }
                Console.WriteLine("DB aktualisiert.");
            }
        }

        static void Listing_40_3()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = (context.Products).FirstOrDefault(p => p.ProductID == 1);
                query.ProductName = "Kuchen";
                // Konflikt simulieren
                Console.WriteLine("2. User simulieren ...");
                Console.ReadLine();
                try
                {
                    // Änderungen speichern
                    context.SaveChanges();
                }
                catch (OptimisticConcurrencyException ex)
                {
                    context.Refresh(RefreshMode.ClientWins, ex.StateEntries[0].Entity);
                    context.SaveChanges();
                }
                Console.WriteLine("DB aktualisiert.");
            }
        }

        static void Listing_40_4()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = (context.Products).FirstOrDefault(p => p.ProductID == 1);
                query.ProductName = "Kuchen";
                // Konflikt simulieren
                Console.WriteLine("2. User simulieren ...");
                Console.ReadLine();
                try
                {
                    // Änderungen speichern
                    context.SaveChanges();
                }
                catch (OptimisticConcurrencyException ex)
                {
                    context.Refresh(RefreshMode.ClientWins, ex.StateEntries[0].Entity);
                    // Ausgabe der Current-Werte des ObjectStateEntry-Objekts
                    Console.WriteLine("Current\n" + new string('-', 50));
                    DbDataRecord actual = ex.StateEntries[0].CurrentValues;
                    for (int i = 0; i < actual.FieldCount - 1; i++)
                        Console.WriteLine("{0,-35}{1}", actual.GetName(i), actual.GetValue(i));
                    // Ausgabe der Original-Werte des ObjectStateEntry-Objekts
                    DbDataRecord original = ex.StateEntries[0].OriginalValues;
                    Console.WriteLine("\nOriginal\n" + new string('-', 50));
                    for (int i = 0; i < original.FieldCount - 1; i++)
                        Console.WriteLine("{0,-35}{1}", original.GetName(i), original.GetValue(i));
                    // Daten speichern
                    context.SaveChanges();
                }
                Console.WriteLine("DB aktualisiert.");
            }
        }
    }
}
