﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace KovarianzSample
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Circle> objects1 = new List<Circle>();
            objects1.Add(new Circle { Radius = 77 });
            objects1.Add(new Circle { Radius = 23 });
            List<Rectangle> objects2 = new List<Rectangle>();
            objects2.Add(new Rectangle { Length = 120, Width = 10 });
            objects2.Add(new Rectangle { Length = 80, Width = 20 });
            DoSomething(objects1);
            DoSomething(objects2);
            Console.ReadLine();
        }

        static void DoSomething(IEnumerable<GeometricObject> param)
        {
            foreach (GeometricObject item in param)
                Console.WriteLine(item.GetArea());
        }
    }


    abstract class GeometricObject
    {
        public abstract double GetArea();
    }

    class Circle : GeometricObject
    {
        public int Radius { get; set; }

        public override double GetArea()
        {
            return Radius;
        }
    }

    class Rectangle : GeometricObject
    {
        public int Length { get; set; }
        public int Width { get; set; }

        public override double GetArea()
        {
            return Length * Width;
        }
    }
}
